/*
 * Copyright (C) 2009 RDC Semiconductor Co.,Ltd
 * All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sub license, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT.
 * IN NO EVENT SHALL PRECISION INSIGHT AND/OR ITS SUPPLIERS BE LIABLE FOR
 * ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * For technical support : 
 *     <rdc_xorg@rdc.com.tw>
 */
 

#define TVMode3              0
#define TVMode6x4            3
#define TVMode7x4            4
#define TVMode7x5            5
#define TVMode8x6            6
#define TVMode1024           7

#define VBE_Mode_3           0x3
#define Mode640x480_8bpp     0x101
#define Mode640x480_16bpp    0x111
#define Mode640x480_32bpp    0x112
#define Mode720x480_8bpp     0x126
#define Mode720x480_16bpp    0x127
#define Mode720x480_32bpp    0x128
#define Mode720x576_8bpp     0x144
#define Mode720x576_16bpp    0x145
#define Mode720x576_32bpp    0x146
#define Mode800x600_8bpp     0x103
#define Mode800x600_16bpp    0x114
#define Mode800x600_32bpp    0x115
#define Mode1024x768_8bpp    0x105
#define Mode1024x768_16bpp   0x117
#define Mode1024x768_32bpp   0x118
#define TVSupportModeCnt     5

#define SAA7105DACPower      0x2D
#define SAA7105DACCCRSLevel  0x5F


extern unsigned char ReadI2C(unsigned char I2CPort, unsigned char I2CSlave, unsigned char RegIdx, unsigned char* RegData);
extern unsigned char WriteI2C(unsigned char I2CPort, unsigned char I2CSlave, unsigned char RegIdx, unsigned char RegData);


extern void SetHTotal(UCHAR DisplayPath, USHORT Value);
extern void SetHDisplayEnd(UCHAR DisplayPath, USHORT Value);
extern void SetHBlankingStart(UCHAR DisplayPath, USHORT Value);
extern void SetHBlankingEnd(UCHAR DisplayPath, USHORT Value);
extern void SetHSyncStart(UCHAR DisplayPath, USHORT Value);
extern void SetHSyncEnd(UCHAR DisplayPath, USHORT Value);
extern void SetVTotal(UCHAR DisplayPath, USHORT Value);
extern void SetVDisplayEnd(UCHAR DisplayPath, USHORT Value);
extern void SetVBlankingStart(UCHAR DisplayPath, USHORT Value);
extern void SetVBlankingEnd(UCHAR DisplayPath, USHORT Value);
extern void SetVSyncStart(UCHAR DisplayPath, USHORT Value);
extern void SetVSyncEnd(UCHAR DisplayPath, USHORT Value);


void SAATest();
void SetSAA7105DACPower(UCHAR ucI2Cport, UCHAR ucDevAddress, UCHAR ucTVConnectorType);
void SetSAA7105InitReg(UCHAR ucI2Cport, UCHAR ucDevAddress);
UCHAR bSetSAA7105Reg(UCHAR bDisplayPath, USHORT wModeNum, UCHAR ucTVType, UCHAR ucI2Cport, UCHAR ucDevAddress);
void SetSAA7105CCRSLevel(UCHAR ucI2Cport, UCHAR ucDevAddress, UCHAR Level);
void GetSAA7105CCRSLevel(UCHAR ucI2Cport, UCHAR ucDevAddress, UCHAR *Level);


struct _SAA7105_Mode_TABLE {
    unsigned char   ucTVModeIndex;
    unsigned short  Mode_ID_8bpp;
    unsigned short  Mode_ID_16bpp;
    unsigned short  Mode_ID_32bpp;
    unsigned char   Reg5Ato66[13];
    unsigned char   Reg6Cto7C[17];
    unsigned char   Reg81to85[5];
    unsigned char   Reg90to9F[16];
    unsigned short  usHTotal;
    unsigned short  usHDisplayEnd;
    unsigned short  usHBlankingStart;
    unsigned short  usHBlankingEnd;
    unsigned short  usHSyncStart;
    unsigned short  usHSyncEnd;
    unsigned short  usVTotal;
    unsigned short  usVDisplayEnd;
    unsigned short  usVBlankingStart;
    unsigned short  usVBlankingEnd;
    unsigned short  usVSyncStart;
    unsigned short  usVSyncEnd;
}__attribute__((packed));;

struct _SAA7105_Init_Reg {
    unsigned char ucIndex;
    unsigned char ucData;
}__attribute__((packed));;

typedef struct _SAA7105_Mode_TABLE SAA7105_Mode_TABLE;
typedef struct _SAA7105_Init_Reg SAA7105_Init_Reg;

SAA7105_Init_Reg SAA7105InitReg[]={
    {0x2D,0x08},
    {0x3A,0x0C},
    {0x16,0x0F},
    {0x17,0x18},
    {0x18,0x18},
    {0x19,0x18},
    {0x54,0x02},
    {0x55,0x0F},
    {0x56,0xC3},
    {0x58,0x02},
    {0x59,0x30},
    {0x7E,0x0C},
    {0x7F,0x0D},
    {0xF9,0x00},
    {0xFA,0x06},
    {0xFD,0x81},
    {0xFF,0xFF}
};

SAA7105_Mode_TABLE CBIOS_NTSC_TV_Mode_Table[TVSupportModeCnt]={
    {TVMode3, VBE_Mode_3, 0x0,0x0, 
            {0x25,0x76,0xaf,0x30,0x3c,0x6e,0x00,0x11,0x3f,0x1f,0x7c,0xf0,0x21},
            {0x01,0x20,0x00,0x06,0x44,0x44,0x61,0x90,0x94,0xb0,0x78,0xf9,0x2a,0xfa,0x1a,0xfb,0x00},
            {0x78,0x89,0x25,0xa5,0x88},
            {0x67,0x7e,0x50,0x50,0x04,0xd0,0x2a,0x21,0x87,0x93,0x71,0x5b,0x7d,0x99,0x99,0x3b},
            824, 640, 648, 816, 712, 762, 570, 480, 488, 562, 468, 495
    },

    {TVMode6x4, Mode640x480_8bpp, Mode640x480_16bpp,Mode640x480_32bpp, 
        {0x25,0x76,0xaf,0x30,0x3c,0x2e,0x25,0x11,0x3f,0x1f,0x7c,0xf0,0x21},
        {0x01,0x26,0x00,0x06,0x60,0x28,0x61,0x90,0x94,0xb0,0x78,0xf9,0x2a,0xfa,0x18,0xfb,0x00},
        {0xea,0x87,0x21,0xa5,0x88},
        {0x81,0x40,0x28,0x28,0x04,0x7d,0x2a,0x20,0x2f,0x94,0x4f,0x20,0x7f,0x90,0x90,0x3b},
        800, 640, 640, 800, 657, 760, 590, 480, 480, 590, 534, 547
    },
    {TVMode7x4, Mode720x480_8bpp, Mode720x480_16bpp, Mode720x480_32bpp,
        {0x25,0x76,0xaf,0x30,0x3c,0xee,0x25,0x11,0x3f,0x1f,0x7c,0xf0,0x21},
        {0x00,0x2d,0x90,0x06,0x42,0x42,0x61,0x90,0x94,0xb0,0x78,0xf9,0x2a,0xfa,0x14,0xfa,0x00},
        {0x30,0x02,0x23,0xA5,0x88},
        {0x51,0x68,0x34,0x36,0x04,0xe8,0x69,0x25,0x7f,0x23,0x39,0xa4,0x7e,0x00,0x00,0x80},
        896, 720, 720, 896, 736, 808, 550, 480, 480, 550, 483, 495
    },
    {TVMode8x6, Mode800x600_8bpp, Mode800x600_16bpp, Mode800x600_32bpp,
        {0x00,0x76,0xaf,0x30,0x3c,0x2e,0x25,0x11,0x3f,0x1f,0x7c,0xf0,0x21},
        {0x01,0x28,0x00,0x06,0x5c,0x28,0x61,0x90,0x94,0xb0,0x78,0xf9,0x2a,0xfa,0x1b,0xf8,0x00},
        {0xa2,0xb0,0x38,0xa5,0x88},
        {0xcf,0x95,0x3d,0x3d,0x04,0x7d,0x2a,0x20,0x2f,0x54,0x2a,0x98,0x5c,0xe9,0xea,0x2a},
        1064, 800, 800, 1064, 840, 972, 750, 600, 600, 750, 670, 700
    },
    {TVMode1024, Mode1024x768_8bpp, Mode1024x768_16bpp, Mode1024x768_32bpp,
        {0x00,0x76,0xa5,0x3a,0x2e,0x2e,0x00,0x15,0x3f,0x1f,0x7c,0xf0,0x21},
        {0x01,0x24,0x00,0x02,0x58,0x34,0x61,0x90,0x94,0xb0,0x78,0xf9,0x2a,0xfa,0x18,0xf5,0x00},
        {0x0a,0xbf,0x4d,0xa5,0x88},
        {0x39,0x00,0x69,0x69,0x08,0x00,0x28,0x21,0x73,0x04,0xb8,0x64,0x49,0x80,0x80,0x2a},
        1152, 1024, 1024, 1152, 1032, 1090, 950, 768, 768, 950,  850, 900
    }    
};

SAA7105_Mode_TABLE CBIOS_PAL_TV_Mode_Table[TVSupportModeCnt]={
    {TVMode3, VBE_Mode_3, 0x0,0x0, 
        {0x00,0x7d,0xaf,0x33,0x35,0x75,0x00,0x02,0x2f,0xcb,0x8a,0x09,0x2a},
        {0x01,0x23,0x80,0x02,0x7e,0x29,0x61,0x90,0x94,0xb0,0x78,0xf9,0x2a,0xfa,0x20,0x22,0x40},
        {0x5c,0x55,0x29,0xa5,0x88},
        {0xda,0x68,0x3d,0x3d,0x04,0xe6,0x2b,0x21,0xec,0x96,0x4a,0x01,0x8d,0x5d,0x5d,0x4c},
        992, 640, 648, 984, 792, 844, 625, 400, 408, 209, 497, 529
    },

    {TVMode6x4, Mode640x480_8bpp, Mode640x480_16bpp,Mode640x480_32bpp, 
        {0x00,0x7d,0xaf,0x33,0x35,0x35,0x00,0x02,0x2f,0xcb,0x8a,0x09,0x2a},
        {0x01,0x25,0x80,0x02,0x68,0x44,0x61,0x90,0x94,0xb0,0x78,0xf9,0x2a,0xfa,0x25,0x25,0x40},
        {0xaa,0x84,0x1d,0xa4,0x88},
        {0xb5,0x80,0x48,0x48,0x08,0xe5,0x29,0x20,0x8f,0x06,0xc7,0x6e,0x87,0x32,0x32,0x4c},
        840, 640, 640, 840, 658, 768, 593, 480, 480, 593, 518, 528
    },
    {TVMode7x5, Mode720x576_8bpp, Mode720x576_16bpp, Mode720x576_32bpp,
        {0x00,0x7d,0xaf,0x33,0x35,0x75,0x00,0x02,0x2f,0xcb,0x8a,0x09,0x2a},
        {0x01,0x23,0x80,0x02,0x58,0x5C,0x61,0x90,0x94,0xb0,0x78,0xf9,0x2a,0xfa,0x13,0x30,0x40},
        {0x0a,0xd7,0x23,0xa5,0x88},
        {0x7F,0x68,0x28,0x28,0x04,0xb8,0x2a,0x20,0x98,0x04,0x46,0x21,0x7e,0x00,0x00,0x2a},
        864, 720, 720, 864, 732, 796, 700, 576, 576, 700, 615, 621
    },
    {TVMode8x6, Mode800x600_8bpp, Mode800x600_16bpp, Mode800x600_32bpp,
        {0x00,0x7d,0xaf,0x33,0x35,0x35,0x00,0x02,0x2f,0xcb,0x8a,0x09,0x2a},
        {0x01,0x26,0x00,0x02,0x68,0x44,0x61,0x90,0x94,0xb0,0x78,0xf9,0x2a,0xfa,0x25,0x25,0x40},
        {0x3f,0xe9,0x2b,0xa5,0x88},
        {0x89,0x90,0x49,0x49,0x04,0xed,0x2a,0x24,0xe7,0x03,0x71,0xba,0x6c,0x60,0x60,0x3b},
        1000, 800, 800, 1000, 858, 940, 741, 600, 600, 741, 625, 665
    },
    {TVMode1024, Mode1024x768_8bpp, Mode1024x768_16bpp, Mode1024x768_32bpp,
        {0x00,0x7d,0xaf,0x33,0x35,0x35,0x00,0x02,0x2f,0xcb,0x8a,0x09,0x2a},
        {0x01,0x22,0x00,0x02,0x68,0x44,0x61,0x90,0x94,0xb0,0x78,0xf9,0x2a,0xfa,0x25,0x25,0x40},
        {0x36,0x8e,0x43,0xa5,0x88},
        {0x9a,0x00,0x66,0x66,0x08,0x00,0x28,0x24,0xaf,0x04,0xb8,0x45,0x59,0xa1,0xa1,0x2a},
        1200, 1024, 1024, 1200, 1041, 1121, 950, 768, 768, 950, 828, 843
    }
};

